diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/nav-menu-template.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/nav-menu-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/nav-menu-template.php	2013-07-10 00:14:43.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/nav-menu-template.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 16,21 ****
--- 16,23 ----
   */
  class Walker_Nav_Menu extends Walker {
  	/**
+ 	 * What the class handles.
+ 	 *
  	 * @see Walker::$tree_type
  	 * @since 3.0.0
  	 * @var string
***************
*** 23,28 ****
--- 25,32 ----
  	var $tree_type = array( 'post_type', 'taxonomy', 'custom' );
  
  	/**
+ 	 * Database fields to use.
+ 	 *
  	 * @see Walker::$db_fields
  	 * @since 3.0.0
  	 * @todo Decouple this.
***************
*** 31,41 ****
  	var $db_fields = array( 'parent' => 'menu_item_parent', 'id' => 'db_id' );
  
  	/**
  	 * @see Walker::start_lvl()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param int $depth Depth of page. Used for padding.
  	 */
  	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
--- 35,49 ----
  	var $db_fields = array( 'parent' => 'menu_item_parent', 'id' => 'db_id' );
  
  	/**
+ 	 * Starts the list before the elements are added.
+ 	 *
  	 * @see Walker::start_lvl()
+ 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param int    $depth  Depth of menu item. Used for padding.
! 	 * @param array  $args   An array of arguments. @see wp_nav_menu()
  	 */
  	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
***************
*** 43,53 ****
  	}
  
  	/**
  	 * @see Walker::end_lvl()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param int $depth Depth of page. Used for padding.
  	 */
  	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
--- 51,65 ----
  	}
  
  	/**
+ 	 * Ends the list of after the elements are added.
+ 	 *
  	 * @see Walker::end_lvl()
+ 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param int    $depth  Depth of menu item. Used for padding.
! 	 * @param array  $args   An array of arguments. @see wp_nav_menu()
  	 */
  	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
***************
*** 55,68 ****
  	}
  
  	/**
  	 * @see Walker::start_el()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item Menu item data object.
! 	 * @param int $depth Depth of menu item. Used for padding.
! 	 * @param int $current_page Menu item ID.
! 	 * @param object $args
  	 */
  	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
--- 67,83 ----
  	}
  
  	/**
+ 	 * Start the element output.
+ 	 *
  	 * @see Walker::start_el()
+ 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item   Menu item data object.
! 	 * @param int    $depth  Depth of menu item. Used for padding.
! 	 * @param array  $args   An array of arguments. @see wp_nav_menu()
! 	 * @param int    $id     Current item ID.
  	 */
  	function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
  		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
***************
*** 72,80 ****
--- 87,113 ----
  		$classes = empty( $item->classes ) ? array() : (array) $item->classes;
  		$classes[] = 'menu-item-' . $item->ID;
  
+ 		/**
+ 		 * Filter the CSS class(es) applied to a menu item's <li>.
+ 		 *
+ 		 * @since 3.0.0
+ 		 *
+ 		 * @param array  $classes The CSS classes that are applied to the menu item's <li>.
+ 		 * @param object $item    The current menu item.
+ 		 * @param array  $args    An array of arguments. @see wp_nav_menu()
+ 		 */
  		$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args ) );
  		$class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';
  
+ 		/**
+ 		 * Filter the ID applied to a menu item's <li>.
+ 		 *
+ 		 * @since 3.0.1
+ 		 *
+ 		 * @param string The ID that is applied to the menu item's <li>.
+ 		 * @param object $item The current menu item.
+ 		 * @param array $args An array of arguments. @see wp_nav_menu()
+ 		 */
  		$id = apply_filters( 'nav_menu_item_id', 'menu-item-'. $item->ID, $item, $args );
  		$id = $id ? ' id="' . esc_attr( $id ) . '"' : '';
  
***************
*** 86,91 ****
--- 119,140 ----
  		$atts['rel']    = ! empty( $item->xfn )        ? $item->xfn        : '';
  		$atts['href']   = ! empty( $item->url )        ? $item->url        : '';
  
+ 		/**
+ 		 * Filter the HTML attributes applied to a menu item's <a>.
+ 		 *
+ 		 * @since 3.6.0
+ 		 *
+ 		 * @param array $atts {
+ 		 *     The HTML attributes applied to the menu item's <a>, empty strings are ignored.
+ 		 *
+ 		 *     @type string $title  The title attribute.
+ 		 *     @type string $target The target attribute.
+ 		 *     @type string $rel    The rel attribute.
+ 		 *     @type string $href   The href attribute.
+ 		 * }
+ 		 * @param object $item The current menu item.
+ 		 * @param array  $args An array of arguments. @see wp_nav_menu()
+ 		 */
  		$atts = apply_filters( 'nav_menu_link_attributes', $atts, $item, $args );
  
  		$attributes = '';
***************
*** 98,122 ****
  
  		$item_output = $args->before;
  		$item_output .= '<a'. $attributes .'>';
  		$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;
  		$item_output .= '</a>';
  		$item_output .= $args->after;
  
  		$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
  	}
  
  	/**
  	 * @see Walker::end_el()
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item Page data object. Not used.
! 	 * @param int $depth Depth of page. Not Used.
  	 */
  	function end_el( &$output, $item, $depth = 0, $args = array() ) {
  		$output .= "</li>\n";
  	}
! }
  
  /**
   * Displays a navigation menu.
--- 147,191 ----
  
  		$item_output = $args->before;
  		$item_output .= '<a'. $attributes .'>';
+ 		/** This filter is documented in wp-includes/post-template.php */
  		$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;
  		$item_output .= '</a>';
  		$item_output .= $args->after;
  
+ 		/**
+ 		 * Filter a menu item's starting output.
+ 		 *
+ 		 * The menu item's starting output only includes $args->before, the opening <a>,
+ 		 * the menu item's title, the closing </a>, and $args->after. Currently, there is
+ 		 * no filter for modifying the opening and closing <li> for a menu item.
+ 		 *
+ 		 * @since 3.0.0
+ 		 *
+ 		 * @param string $item_output The menu item's starting HTML output.
+ 		 * @param object $item        Menu item data object.
+ 		 * @param int    $depth       Depth of menu item. Used for padding.
+ 		 * @param array  $args        An array of arguments. @see wp_nav_menu()
+ 		 */
  		$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
  	}
  
  	/**
+ 	 * Ends the element output, if needed.
+ 	 *
  	 * @see Walker::end_el()
+ 	 *
  	 * @since 3.0.0
  	 *
  	 * @param string $output Passed by reference. Used to append additional content.
! 	 * @param object $item   Page data object. Not used.
! 	 * @param int    $depth  Depth of page. Not Used.
! 	 * @param array  $args   An array of arguments. @see wp_nav_menu()
  	 */
  	function end_el( &$output, $item, $depth = 0, $args = array() ) {
  		$output .= "</li>\n";
  	}
! 
! } // Walker_Nav_Menu
  
  /**
   * Displays a navigation menu.
***************
*** 152,157 ****
--- 221,233 ----
  	'depth' => 0, 'walker' => '', 'theme_location' => '' );
  
  	$args = wp_parse_args( $args, $defaults );
+ 	/**
+ 	 * Filter the arguments used to display a navigation menu.
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param array $args Arguments from {@see wp_nav_menu()}.
+ 	 */
  	$args = apply_filters( 'wp_nav_menu_args', $args );
  	$args = (object) $args;
  
***************
*** 196,201 ****
--- 272,284 ----
  
  	$show_container = false;
  	if ( $args->container ) {
+ 		/**
+ 		 * Filter the list of HTML tags that are valid for use as menu containers.
+ 		 *
+ 		 * @since 3.0.0
+ 		 *
+ 		 * @param array The acceptable HTML tags for use as menu containers, defaults as 'div' and 'nav'.
+ 		 */
  		$allowed_tags = apply_filters( 'wp_nav_menu_container_allowedtags', array( 'div', 'nav' ) );
  		if ( in_array( $args->container, $allowed_tags ) ) {
  			$show_container = true;
***************
*** 208,219 ****
  	// Set up the $menu_item variables
  	_wp_menu_item_classes_by_context( $menu_items );
  
! 	$sorted_menu_items = array();
! 	foreach ( (array) $menu_items as $key => $menu_item )
! 		$sorted_menu_items[$menu_item->menu_order] = $menu_item;
  
! 	unset($menu_items);
  
  	$sorted_menu_items = apply_filters( 'wp_nav_menu_objects', $sorted_menu_items, $args );
  
  	$items .= walk_nav_menu_tree( $sorted_menu_items, $args->depth, $args );
--- 291,320 ----
  	// Set up the $menu_item variables
  	_wp_menu_item_classes_by_context( $menu_items );
  
! 	$sorted_menu_items = $menu_items_with_children = array();
! 	foreach ( (array) $menu_items as $menu_item ) {
! 		$sorted_menu_items[ $menu_item->menu_order ] = $menu_item;
! 		if ( $menu_item->menu_item_parent )
! 			$menu_items_with_children[ $menu_item->menu_item_parent ] = true;
! 	}
! 
! 	// Add the menu-item-has-children class where applicable
! 	if ( $menu_items_with_children ) {
! 		foreach ( $sorted_menu_items as &$menu_item ) {
! 			if ( isset( $menu_items_with_children[ $menu_item->ID ] ) )
! 				$menu_item->classes[] = 'menu-item-has-children';
! 		}
! 	}
  
! 	unset( $menu_items, $menu_item );
  
+ 	/**
+ 	 * Filter the sorted list of menu item objects before generating the menu's HTML.
+ 	 *
+ 	 * @since 3.1.0
+ 	 *
+ 	 * @param array $sorted_menu_items The menu items, sorted by each menu item's menu order.
+ 	 */
  	$sorted_menu_items = apply_filters( 'wp_nav_menu_objects', $sorted_menu_items, $args );
  
  	$items .= walk_nav_menu_tree( $sorted_menu_items, $args->depth, $args );
***************
*** 235,242 ****
  
  	$wrap_class = $args->menu_class ? $args->menu_class : '';
  
! 	// Allow plugins to hook into the menu to add their own <li>'s
  	$items = apply_filters( 'wp_nav_menu_items', $items, $args );
  	$items = apply_filters( "wp_nav_menu_{$menu->slug}_items", $items, $args );
  
  	// Don't print any markup if there are no items at this point.
--- 336,358 ----
  
  	$wrap_class = $args->menu_class ? $args->menu_class : '';
  
! 	/**
! 	 * Filter the HTML list content for navigation menus.
! 	 *
! 	 * @since 3.0.0
! 	 *
! 	 * @param string $items The HTML list content for the menu items.
! 	 * @param array $args Arguments from {@see wp_nav_menu()}.
! 	 */
  	$items = apply_filters( 'wp_nav_menu_items', $items, $args );
+ 	/**
+ 	 * Filter the HTML list content for a specific navigation menu.
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param string $items The HTML list content for the menu items.
+ 	 * @param array $args Arguments from {@see wp_nav_menu()}.
+ 	 */
  	$items = apply_filters( "wp_nav_menu_{$menu->slug}_items", $items, $args );
  
  	// Don't print any markup if there are no items at this point.
***************
*** 249,254 ****
--- 365,378 ----
  	if ( $show_container )
  		$nav_menu .= '</' . $args->container . '>';
  
+ 	/**
+ 	 * Filter the HTML content for navigation menus.
+ 	 *
+ 	 * @since 3.0.0
+ 	 *
+ 	 * @param string $nav_menu The HTML content for the navigation menu.
+ 	 * @param array $args Arguments from {@see wp_nav_menu()}.
+ 	 */
  	$nav_menu = apply_filters( 'wp_nav_menu', $nav_menu, $args );
  
  	if ( $args->echo )
